var AdapterJWPlayer = $.extend({}, AdapterPlayer, {
	
	_startTime: 0,
	_player: null,
	_started: false,
	
	_playerType: 'html5',
	
	init: function (url, start, type) {
		
		var _this = this;	
			
		this._startTime = start;
		
		this._player = jwplayer("player").setup({
		    file: url,
		    type: this._toPlayerType(url, type),
			autostart: true,
			primary: this._playerType,
			controls: false,
			startparam: 'start',
			width: '100%',
			height: '100%'
		});
		
		this._player.onBeforeComplete(function () {
			_this.onEnd();
		});
		
		this._player.onError(function () {
			_this.onError();
		});
		
		var _onStartTimer = null;
		this._player.onPlay(function () {
			
			clearInterval(_onStartTimer);
			_onStartTimer = setInterval(function () {
				
				if (_this.getCurrentTime() > 0 && _this._started == false) {
					_this._started = true;
					clearInterval(_onStartTimer);
					_this._onStart();
				}
				
			}, 500);

			_this.onPlay();
			_this.onBufferEnd();

		});
		
		this._player.onReady(function () {
			_this.onInit();
		});
		
		this._player.onBuffer(function () {
			_this.onBuffer();
		});
		
	},
	
	play: function () {
		this._player.play(true);
	},
	
	pause: function () {
		this._player.pause(true);
	},
	
	destroy: function () {
		if (this._player) {
			try {
				this._player.stop();
				this._player.remove();
			}
			catch(e) {}
		}
		this._player = null;
		this._playerType = 'html5';
		this._started = false;
	},
	
	isPaused: function () {
		return this._player ? (this._player.getState() == 'PAUSED') : false;
	},
	
	getCurrentTime: function () {
		return this._player ? this._player.getPosition() : false;
	},
	
	getDuration: function () {
		return this._player.getDuration();
	},
	
	seekTo: function(skipSeconds) {
		_log('seekTo: ' + skipSeconds);
		this._player.seek(skipSeconds);
		this.play();
	},
	
	onEnd: function () {},
	onError: function () {},
	onPlay: function () {},
	onInit: function () {},
	onBuffer: function () {},
	onBufferEnd: function () {},
	
	/**
	 * Конвертирует mime тип видео в формат для плеера
	 *
	 * @param string mime	тип фильма
	 * @return string
	 */
	_toPlayerType: function (url, mime) {

		if (url.indexOf('.m3u8') != -1) {
			return 'application/x-mpegurl';
		}
		
		var type = 'mp4';
		
		if (mime) {
			
			switch (mime) {
				case 'video/webm':
				case 'video/x-matroska':
				case 'video/x-flv':
						type = 'mp4';
					break;
					
				default:
						type = mime;
					break;
					
			}
		
		}
		
		return type;

	},
	
});