var AdapterPlayer = {
	
	_adapter: null,
	_errorCounter: 0,
	_errorTimer: null,
	//_bufferTimer: null,
	
	_initInfo: {
		url: null,
		type: null,
		start: null
	},
	
	setAdapter: function (adapter) {
		this._adapter = adapter;
	},
	
	init: function (url, start, type, id) {
		_log('AdapterPlayer: init, url: ' + url);
		this._initInfo = {
			url: url,
			start: start,
			type: type,
			id: id
		};
		return this._adapter.init(url, start, type, id);
	},
	
	play: function () {
		return this._adapter.play();
	},
	
	pause: function () {
		return this._adapter.pause();
	},
	
	destroy: function () {
		//clearInterval(this._bufferTimer);
		this._errorCounter = 0;
		return this._adapter.destroy();
	},
	
	getCurrentTime: function () {
		return this._adapter.getCurrentTime();
	},
	
	getDuration: function () {
		return this._adapter.getDuration();
	},
	
	isPaused: function () {
		return this._adapter.isPaused();
	},
	
	seekTo: function(skipSeconds) {
		if (this.getDuration() > 0) {
			return this._adapter.seekTo(skipSeconds);
		}
	},
	
	onEnd: function (callback) {
		return this._adapter.onEnd = function () {
			_log('AdapterPlayer: onEnd');
			callback();
		};
	},
	
	onError: function (callback) {
		
		var _this = this;
		
		return this._adapter.onError = function () {
			callback();
		};

		
	},
	
	onPlay: function (callback) {
		var _this = this;
		return this._adapter.onPlay = function () {
			_log('AdapterPlayer: onPlay');
			clearTimeout(_this._errorTimer);
			callback();
		};
	},
	
	onInit: function (callback) {
		
		var _this = this;
		
		return this._adapter.onInit = function () {
			
			_log('AdapterPlayer: onInit');
			
			callback();
			
			clearTimeout(_this._errorTimer);
	
			_this._errorTimer = setTimeout(function () {
				if (!parseInt(_this.getCurrentTime())) {
					_this._adapter.onError();
				}
			}, 60 * 1000);
			
		};
	},
	
	onBuffer: function (callback) {
		return this._adapter.onBuffer = function () {
			_log('AdapterPlayer: onBuffer');
			callback();
		};
	},
	
	onBufferEnd: function (callback) {
		return this._adapter.onBufferEnd = function () {
			_log('AdapterPlayer: onBufferEnd');
			callback();
		};
	},
	
	_onStart: function () {

		var _this = this,
			_seekStart= null;
		
		if (this._startTime) {
			_seekStart = setInterval(function () {
				if (parseInt(_this.getCurrentTime()) > 1 && _this.getDuration() > 0) {
					clearInterval(_seekStart);
					_this.seekTo(_this._startTime);
				}
				_log('Пробуем перемотать на ' + _this._startTime)
			}, 100);
		}
			
	}
	
}