var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();


var Main = {
	
	_blockKeys: false,
	
	version: function () {
		return '2.0.2';
	},
	
	onLoad: function() {

		this.enableKeys();
	
		window.onShow = this.onShowEvent;
		widgetAPI.sendReadyEvent();
		
	},
	
	onUnload: function() { },
	
	enableKeys: function() {
		
		$('body')
			.keydown(this.keyDown)
			.focus();

	},
	
	blockKeys: function () {
		this._blockKeys = true;
	},
	
	unBlockKeys: function () {
		this._blockKeys = false;
	},
	
	keyDown: function() {
			
		if (Main._blockKeys) return false;
		
		var keyCode = event.keyCode;
		alert("Key pressed: " + keyCode);
		alert("block: " + this._blockKeys);
	
		switch(keyCode)
		{
			case tvKey.KEY_EXIT:
				alert("EXIT");
				Scene.onPressExit();
				widgetAPI.blockNavigation(event);
				break;
			case tvKey.KEY_RETURN:
			case tvKey.KEY_PANEL_RETURN:
				alert("RETURN");
				Scene.onPressReturn();
				widgetAPI.blockNavigation(event);
				break;
			case tvKey.KEY_LEFT:
				alert("LEFT");
				Scene.onPressLeft();
				break;
			case tvKey.KEY_RIGHT:
				alert("RIGHT");
				Scene.onPressRight();
				break;
			case tvKey.KEY_UP:
				alert("UP");
				Scene.onPressUp();
				break;
			case tvKey.KEY_DOWN:
				alert("DOWN");
				Scene.onPressDown();
				break;
			case tvKey.KEY_ENTER:
			case tvKey.KEY_PANEL_ENTER:
				alert("ENTER");
				Scene.onPressEnter();
				break;
			case tvKey.KEY_VOL_UP:
			case tvKey.KEY_VOL_DOWN:
			case tvKey.KEY_MUTE:
				alert("Volumes key");
				break;
			case tvKey.KEY_1:
				alert("KEY_1");
				Scene.onPress1();
				break;
			case tvKey.KEY_2:
				alert("KEY_2");
				Scene.onPress2();
				break;
			case tvKey.KEY_3:
				alert("KEY_3");
				Scene.onPress3();
				break;
			case tvKey.KEY_4:
				alert("KEY_4");
				Scene.onPress4();
				break;
			case tvKey.KEY_5:
				alert("KEY_5");
				Scene.onPress5();
				break;
			case tvKey.KEY_6:
				alert("KEY_6");
				Scene.onPress6();
				break;
			case tvKey.KEY_7:
				alert("KEY_7");
				Scene.onPress7();
				break;
			case tvKey.KEY_8:
				alert("KEY_8");
				Scene.onPress8();
				break;
			case tvKey.KEY_9:
				alert("KEY_9");
				Scene.onPress9();
				break;
			case tvKey.KEY_0:
				alert("KEY_0");
				Scene.onPress0();
				break;
			case tvKey.KEY_FF:
				alert("KEY_FF");
				Scene.onPressFF();
				break;
			case tvKey.KEY_RW:
				alert("KEY_RW");
				Scene.onPressRF();
				break;
			case tvKey.KEY_STOP:
				alert("KEY_STOP");
				Scene.onPressStop();
				break;
			case tvKey.KEY_PLAY:
				alert("KEY_PLAY");
				Scene.onPressPlay();
				break;
			case tvKey.KEY_PAUSE:
				alert("KEY_PAUSE");
				Scene.onPressPause();
				break;
			case tvKey.KEY_RED:
				alert("KEY_RED");
				Scene.onPressA();
				break;
			case tvKey.KEY_GREEN:
				alert("KEY_GREEN");
				Scene.onPressB();
				break;
			case tvKey.KEY_YELLOW:
				alert("KEY_YELLOW");
				Scene.onPressC();
				break;
			case tvKey.KEY_BLUE:
				alert("KEY_BLUE");
				Scene.onPressD();
				break;
			case tvKey.KEY_ASPECT:
				alert("KEY_ASPECT");
				Scene.onPressAspect();
				break;
			case tvKey.KEY_3D:
				alert("KEY_3D");
				Scene.onPress3D();
				widgetAPI.blockNavigation(event);
				break;
			case tvKey.KEY_INFO:
				alert("KEY_INFO");
				Scene.onPressInfo();
				break;
			default:
				alert("Unhandled key");
				break;
		}
	},

	GetMac: function () {

		var networkPlugin = document.getElementById('pluginObjectNetwork');
	    var _mac = networkPlugin.GetMAC(networkPlugin.GetActiveType());
	    
	    return _mac ? _mac : 'debug';

	},
	
	onShowEvent: function() {
		
		var nnaviPlugin = document.getElementById('pluginObjectNNavi');
	    
	    nnaviPlugin.SetBannerState(1);
	
	    // For volume OSD
	    pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	    pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	    pluginAPI.unregistKey(tvKey.KEY_MUTE);
	    pluginAPI.registKey(tvKey.KEY_3D); 
	    
	    pluginAPI.setOffScreenSaver();
	   
	}

};


var formatTime = function(seconds, guide) {
	
	guide = guide || seconds; // Default to using seconds as guide
	var s = Math.floor(seconds % 60),
	    m = Math.floor(seconds / 60 % 60),
	    h = Math.floor(seconds / 3600),
	    gm = Math.floor(guide / 60 % 60),
	    gh = Math.floor(guide / 3600);
	
	// Check if we need to show hours
	h = (h > 0 || gh > 0) ? h + ":" : "";
	
	// If hours are showing, we may need to add a leading zero.
	// Always show at least one digit of minutes.
	m = (((h || gm >= 10) && m < 10) ? "0" + m : m) + ":";
	
	// Check if leading zero is need for seconds
	s = (s < 10) ? "0" + s : s;
	
	return h + m + s;

}

var _log = function (message) {
	$('#debug').prepend(message + '<br/>');
}

var _debug = function (message) {
	$.get('http://playontv.net/mvc/publications/tv/debug', {message: message});
}

window.onerror = function (message, source, lineno) {
	_log('ERROR: ' + message + '<br/>file: ' + source + '(' + lineno + ')');
};
