const BASE_URL = 'http://playontv.net/';

/**
 * Титульная страница
 */
var IndexScene = $.extend({}, iBlock, {

	/**
	 * @var object обертка для родительского элемента
	 */
	_wrapper: null,
	
	_autoPlay: false,
	
	/**
	 * @var string Уникальный ID SmasrtTV
	 */
	_macAddr: Main.GetMac(),

	/**
	 * @var int ID последнего загруженного фильма
	 */
	_lastFilmId: 0,

	/**
	 * @var object Информация о проигрываемом видео
	 */
	_currentFilm: {
		id: null,
		url: null,
		content_type: null
	},

	
	onFocus: function () {
		
		var _this = this;

		$('#body').tmp(this._templates.index(), {mac: this._macAddr});
		this._wrapper = $('#films');
		this._wrapper.customScrollbar();
		
		this._startObserve();
		
	},
	
	onBlur: function () {

		for (i in this._timers) {
			clearInterval(this._timers[i]);
			clearTimeout(this._timers[i]);
		}

		this._lastFilmId = 0;
		this._wrapper = null;
		
		this._stopObserve();
		
	},
	
	onPress0: function () {
		$('#debug').toggle();
	},
	
	onPressInfo: function () {
		this.jumpTo('manual');
	},
	
	onPressUp: function() {
		
		var _next = $('.active', this._wrapper).length && $('.active', this._wrapper).prev('li').length
			? $('.active', this._wrapper).prev('li')
			: $('LI:last', this._wrapper)
			
		$('.active', this._wrapper).removeClass('active');
		_next.addClass('active');
		
		this._scrollToActive();
		
	},
	
	onPressDown: function() {
		
		var _next = $('.active', this._wrapper).length && $('.active', this._wrapper).next('li').length
			? $('.active', this._wrapper).next('li')
			: $('LI:first', this._wrapper);
				
		$('.active', this._wrapper).removeClass('active');
		$(_next).addClass('active');
		
		this._scrollToActive();
		
	},
	
	onPressPlay: function () {
				
		var _this = this
			_activeObj = $('.active', this._wrapper);
		
		if (_activeObj.length) {
			
			var _url = _activeObj.data('url'),
				_youtubeUrl = httpTransport.youtubeUrl(_url);
			
			_this._currentFilm = {
				id: _activeObj.data('id'),
				url: _youtubeUrl ? _youtubeUrl : _url,
				content_type: _activeObj.data('content_type')
			}
			
			var _play = function (time_shift) {
				_this.jumpTo('video', $.extend({}, _this._currentFilm, {time_shift: time_shift}));
			}
			
			var _time_shift = _this.getTimeshift(_this._currentFilm.id);
			if (_time_shift > 0 && _this._autoPlay == false) {
				Dialog.confirm('Это видео уже просматривалось. Продолжить с места последнего просмотра (' + formatTime(_time_shift) + ')?', 'Внимание!', function (status) {
					_play(status ? _time_shift : 0);
				}, 'Да', 'Нет');
				
			}
			else {
				_play(0);
			}
			
		}
		else {
			Dialog.alert('Вы не отправили ни одного фильма на ваш SmartTV.')
		}
		
	},
	
	onPressFF: function () {
		
		var _this = this,
			_activeObj = $('.active', this._wrapper);
		
		if (_activeObj.length) {
		
			Dialog.confirm('Воиспроизвести все видео?', 'Внимание!', function (status) {
				if (status) {
					_this._autoPlay = status;
					_this.onPressPlay();
				}
			}, 'Да', 'Нет');
			
		}
		else {
			Dialog.alert('Вы не отправили ни одного фильма на ваш SmartTV.')
		}
		
	},
	
	onPressReturn : function () {
		widgetAPI.sendReturnEvent();
		widgetAPI.blockNavigation(event);
	},
	
	onPressEnter: function() {
		this.onPressPlay();
	},
	
	onPressA: function() {
		this.jumpTo('favorites');
	},
	
	onPressC: function() {
		return;
		//this.jumpTo('popular');
	},
	
	onPressB: function() {

		var _this = this,
			_activeObj = $('.active', this._wrapper);

		$('.favorite', _activeObj).length 
			? $('.favorite', _activeObj).remove()
			: $('div', _activeObj).append('<i class="favorite"/>')

		httpTransport.favoriteToggleFilm(_activeObj.data('id'));
		
	},
	
	onPressD: function() {
		
		var _this = this,
			_activeObj = $('.active', this._wrapper);
			
		if (!_activeObj.length) {
			Dialog.alert('Вы не добавили ни одного файла для воспроизведения.', 'У вас отсутствуют файлы для удаления');
		}
		else {
	
			Dialog.confirm('Внимание, эту операцию нельзя отменить. Удалить видео?', 'Удалить видео из списка?', function (status) {
	
				if (status) {
					
					httpTransport.deleteFilm(_activeObj.data('id'), function () {
						
						setTimeout(function () { _activeObj.remove() }, 500);
						
						_activeObj.next('li').length
							? _this.onPressDown()
							: _this.onPressUp();
		
					});

				}
			
			}, 'Да', 'Нет');
			
		}

	},
	
	
	saveTimeshift: function (time) {
		$.cookie('playontv_ts_' + this._currentFilm.id, time, {expires: 15});
	},
	
	getTimeshift: function(film_id) {
		return $.cookie('playontv_ts_' + film_id);
	},
	
	isMessageRead: function (id) {
		var _messages = this._messagesRead();
		return in_array(id, _messages);
	},
	setMessageRead: function (id) {
		var _messages = this._messagesRead();
		_messages.push(id);
		$.cookie('messages', serialize(_messages), {expires: 365});
	},
	_messagesRead: function () {
		return $.cookie('messages') ? unserialize($.cookie('messages')) : [];
	},
	
	completeFilm: function () {
		this.saveTimeshift(0);
	},
	
	stopAuto: function () {
		this._autoPlay = false;
	},
	
	/**
	 * Прокрутка до активного элемента
	 *
	 * @return self
	 */
	_scrollToActive: function () {
		
		if (this._wrapper) {
			
			this._wrapper
				.customScrollbar('resize', true)
				.customScrollbar("scrollTo", $('.active', this._wrapper));

		}

	},
	
	writeFilms: function (data) {
	
		var _this = this;
		
		if (data.length) {
			
			$('.overview', _this._wrapper).tmpPrepend(_this._templates.rowFilm(), data);
			
			if (_this._currentFilm.id) {
				$('li[data-id=' + _this._currentFilm.id + ']', _this._wrapper).addClass('active');
			}
			else if (!_this._lastFilmId) {
				_this.onPressDown();
			}

			_this._scrollToActive();
			_this._lastFilmId = data[0].publication_id;
			
			if (_this._autoPlay) {
				_this.onPressDown();
				_this.onPressPlay();
			}

		}
		
	},
	
	_startObserve: function () {
				
		this._stopObserve();
		this._timer = setInterval(this._adapterObserver, 10 * 1000);

		this._adapterObserver();
		
	},
	
	_stopObserve: function () {
		clearInterval(this._timer);
	},
	
	_adapterObserver: function () {

		var _this = IndexScene;
		
		httpTransport.getFilms(_this._lastFilmId, function (data) {
			if (Scene.current.name == _this.name) {
				_this.writeFilms(data);
			}
		});
			
	},
	
	_templates: {
		
		index: function () {
			
			return '<div id="index_scene">\
						<img id="logo" src="./app/images/logo.png"/>\
						<h1>Файлы доступные для просмотра<span id="throbber_placeholder"></span></h1>\
						<div id="films"></div>\
					</div>\
					<div id="bottom_images">\
						<div class="info">Ваш SmartID: {{=it.mac}}</div>\
						<span id="red">Избранное</span>\
						<span id="green">Добавить в избранное</span>\
						<span id="blue">Удалить</span>\
						<span id="ff">Играть всё</span>\
						<span id="info">Помощь</span>\
						<span id="return">Выход</span>\
					</div>\
				';
			
		},
		
		rowFilm: function () {
			
			return '<li id="film_{{=it.publication_id}}" data-id="{{=it.publication_id}}" data-url_from="{{=it.url_from}}" data-url="{{=it.url}}" data-content_type="{{=it.content_type}}">\
				{{? it.favicon }}<img src="{{=it.favicon}}"/>{{?}}\
				<div><span>{{=it.title}}</span>\
					{{? it.favorite }}<i class="favorite"></i>{{?}}\
				</div>\
			</li>';
			
		}
		
	}

});
