/**
 * Отобраение диалоговых окон в приложении
 */
var Dialog = $.extend({}, iBlock, {
	
	_currentActiveBlock: null,
	_callback: null,
	_type: 'alert',
	
	init: function () {

		var _this = this;
		
		$(document).on('click', '#dialog .button', function () {
			
			$('#dialog .button').addClass('button_unactive');
			$(this).removeClass('button_unactive');
			_this.onPressEnter();

			return false;

		});
		
	},
	
	alert: function(message, title, callback, btnMessage) {
		
		this._callback = callback;
		this._type = 'alert';
		
		title = title || 'Внимание';
		btnMessage = btnMessage || 'Ok';
		
		this._currentActiveBlock = Scene.current;
		Scene.current = this;
		
		$('#dialog').remove();
		$('body').append(
			'<div id="dialog" class="alert_dialog">'
				+ '<div class="overflow_all"></div>'
				+ '<div class="window">'
					+ '<div class="title">' + title + '</div>'
					+ '<div class="message">' + message + '</div>'
					+ '<div class="button">' + btnMessage + '</div>'
				+ '</div>'
			+ '</div>'
		);
		
	},
	
	confirm: function(message, title, callback, btnMessage, btnMessageCancel) {
		
		this._callback = callback;
		this._type = 'confirm';
		
		title = title || 'Внимание';
		btnMessage = btnMessage || 'Ok';
		btnMessageCancel = btnMessageCancel || 'Cancel';
		
		this._currentActiveBlock = Scene.current;
		Scene.current = this;
		
		$('#dialog').remove();
		$('body').append(
			'<div id="dialog" class="confirm_dialog">'
				+ '<div class="overflow_all"></div>'
				+ '<div class="window">'
					+ '<div class="title">' + title + '</div>'
					+ '<div class="message">' + message + '</div>'
					+ '<div class="button btnconfirm button_ok">' + btnMessage + '</div>'
					+ '<div class="button btnconfirm button_cancel button_unactive">' + btnMessageCancel + '</div>'
				+ '</div>'
			+ '</div>'
		);
		
	},
	
	onPressEnter: function () {
		
		Scene.current = this._currentActiveBlock;

		if (typeof this._callback == 'function') {
			this._callback($('#dialog .button_cancel').is('.button_unactive'));
		}

		$('#dialog').remove();
		
	},
	onPressReturn: function () {
		
		Scene.current = this._currentActiveBlock;
		$('#dialog').remove();
		
		if (this._type == 'alert' && typeof this._callback == 'function') {
			this._callback($('#dialog .button_cancel').is('.button_unactive'));
		}
		
	},
	onPressRight: function () {
		$('#dialog .btnconfirm').toggleClass('button_unactive');
	},
	onPressLeft: function () {
		this.onPressRight();
	}
});