const _PLAYONTV_SITE = 'http://playontv.net';

var httpTransport = {
	
	_links: {
		newFilms: _PLAYONTV_SITE + '/mvc/publications/tv/get/',				// Получаем список новых фильмов
		favoriteFilms: _PLAYONTV_SITE + '/mvc/publications/tv/favorites/',	// Получаем список избранных фильмов
		favoriteToggle: _PLAYONTV_SITE + '/mvc/publications/tv/favoritetoggle/',	// Изменяем статус избранного у фильма
		deleteFilm: _PLAYONTV_SITE + '/mvc/publications/tv/delete/'			// Удаляем фильм из списка
	},
	
	/**
	 * Получаем фильмы пользователя
	 * @param int lastId
	 * @param function callback
	 * @return self
	 */
	getFilms: function(lastId, callback) {
	
		$.getJSON(this._links.newFilms, {format: 'json', last_id: lastId}, function (data) {
			
			if (typeof(callback) == 'function') {
				callback(data.films);
			}

		});
		
		return this;
		
	},

	/**
	 * Получаем избранные фильмы пользователя
	 * @param int lastId
	 * @param function callback
	 * @return self
	 */
	getFovoriteFilms: function(lastId, callback) {
	
		$.getJSON(this._links.favoriteFilms, {format: 'json', last_id: lastId}, function (data) {
			if (typeof(callback) == 'function') {
				callback(data.films);
			}
		});
		
		return this;
		
	},

	/**
	 * Удаление фильма
	 * @param int filmId
	 * @param function callback
	 * @return self
	 */
	deleteFilm: function (filmId, callback) {

		$.get(this._links.deleteFilm, {film_id: filmId}, function (data) {
			if (typeof(callback) == 'function') {
				callback(data);
			}
		});
		
		return this;

	},
	
	/**
	 * Изменение статуса "в избранном" у фильма
	 * @param int filmId
	 * @param function callback
	 * @return self
	 */
	favoriteToggleFilm: function (filmId, callback) {

		$.get(this._links.favoriteToggle, {film_id: filmId}, function (data) {
			if (typeof(callback) == 'function') {
				callback(data);
			}
		});
		
		return this;

	},

	/**
	 * Получаем ссылку на Youtube из ID ролика
	 * @param string youtubeId
	 * @return string
	 */
	youtubeUrl: function (youtubeId) {
		
		if (-1 == youtubeId.indexOf('://')) {
			
			var _return = $.ajax({
				url: 'http://www.youtube.com/get_video_info?video_id=' + youtubeId,
				error: function(jqXHR, exception) {
					_log(exception);
				},
				async: false
			}).responseText;
			
			var _re = /hlsvp=(.*?)&/;
			var _matches = _return.match(_re);

			if (_matches) { // прямой эфир
				var _url = decodeURIComponent(_matches[1]);
			}
			else {
				var _re = /url_encoded_fmt_stream_map=(.*?)&/,
					_reUrl = /url=(.*?)&/;
	
				var _matches =  _return.match(_re),
					_matches = decodeURIComponent(_matches[1]),
					_url = _matches.match(_reUrl),
					_url = decodeURIComponent(_url[1]);
					
			}
			
			return _url.replace(/,.+$/, '');

		}
		
		return false;
		
	},
	
}